-- Selecciona l'element en posició n de la llista

seln _ [] = 0
seln 0 _  = 0
seln 1 (x:xs) = x
seln n (x:xs) = seln (n-1) xs

-- ordena la llista amb quicksort

quicksort []     = []
quicksort (p:xs) = (quicksort lesser) ++ [p] ++ (quicksort greater)
    where
        lesser  = filter (< p) xs
        greater = filter (>= p) xs

-- obtenir l'element n en ordre de la llista
-- O(n + k log k) en mitjana

nthord n = seln n . quicksort 


-- obtenir l'element n en ordre de la llista
-- O(n) en mitjana

qnthord k (p:xs)  
	|sl >=k = (qnthord k lesser) 
	|sl <k-1 = (qnthord (k-sl-1) greater) 
        | otherwise = p 
    where
        lesser  = filter (< p) xs
        greater = filter (>= p) xs
	sl = (length lesser)


